function CommentView(model, frame) {
  var document = frame.contentDocument;
  var root = document.documentElement;

  var body = root.getElementsByTagName("body").item(0);
  var head = root.getElementsByTagName("head").item(0);

  var pat = /([a-hj-tw]\d+)/ig;

  addStyleLink("chrome://foxgo/skin/foxgo-comments.css");

  function addStyleLink(location) {
    var style = document.createElement("link");

    style.setAttribute("rel", "stylesheet");
    style.setAttribute("type", "text/css");
    style.setAttribute("href", location);
    
    head.appendChild(style);
  }

  function clear() {
    var children = body.childNodes;
    var length = children.length;

    for (var i = length - 1; i >= 0; i--) {
      body.removeChild(children.item(i));
    }
  }

  function handleClick(evt, coord) {
    if (evt.ctrlKey) {
      FoxGo.controller.flashMove(coord);
    } else {
      FoxGo.controller.flashCoordinate(coord);
    }
  }

  function addParagraph(str) {
    if (str == undefined) {
      return;
    }

    var p = document.createElement("P");
    var match;

    while ((match = pat.exec(str)) != undefined) {
      var start = str.substring(0, match.index);
      var link = document.createElement("A");

      eval('link.addEventListener("click", function(evt) { ' +
           '                        handleClick(evt, "' + match[1] + '")' +
           '                      }, true);');

      p.appendChild(document.createTextNode(start));
      link.appendChild(document.createTextNode(match[1]));
      p.appendChild(link);

      str = str.substring(pat.lastIndex);
      pat.lastIndex = 0;
    }

    if (str.length > 0) {
      p.appendChild(document.createTextNode(str));
    }

    body.appendChild(p);
  }

  this.refresh = function() {
    clear();
    
    addParagraph(model.getName());

    model.getComments().forEach(function (comments) { 
      var paras = comments.split('\n');

      paras.forEach(function (comment) {
        addParagraph(comment);
      });
    });
  }
}
